<template>
  <!-- Подсказка -->
  <el-tooltip
    effect="light"
    placement="top"
    :enterable="false"
    content="Размещение по втянутым рейтингам (вкл.), иначе по текущим (выкл.)"
  >
    <!-- Форма -->
    <el-form-item label="Размещение по втянутым рейтингам">
      <!-- Переключатель -->
      <el-switch v-model="value" @change="onChange" />
    </el-form-item>
  </el-tooltip>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import ComponentMixin from "@/components/common/ComponentMixin";
import { MediaPlanParameters } from "@/interfaces/parameters/MediaPlanParameters";

/**
 * Компонент переключения типа размещения рейтингов.
 */
@Component
export default class RatingPlacementTypeComponent extends Mixins(
  ComponentMixin
) {
  /**
   * @private
   * Значение в элементе.
   */
  private value = true;

  /**
   * @private
   * Параметры автоматического размещения медиаплана.
   */
  private parameters: MediaPlanParameters | null = null;

  /**
   * Метод вызывается после создания компонента.
   */
  created(): void {
    // Подписываемся на событие получения параметров автоматического размещения.
    this.subscribe(
      "media-plan-parameters-response-from-parent",
      this.onParametersResponse
    );
  }

  /**
   * @private
   * Метод вызывается, когда изменяется значение в элементе.
   */
  private onChange(): void {
    // Если есть параметры
    if (this.parameters) {
      // Переключаем признак "размещение по втянутым рейтингам"
      this.parameters.isAssignedRatingsPlacement = this.value;
    }
  }

  /**
   * @private
   * Метод вызывается при получении параметров автоматического размещения.
   * @param parameters параметры автоматического размещения.
   */
  private onParametersResponse(parameters: MediaPlanParameters): void {
    // Сохраняем параметры в свойство компонента
    this.parameters = parameters;
    // Меняем значение элемента
    this.value = this.parameters.isAssignedRatingsPlacement;
  }
}
</script>
